package testcases.{{ task_name }};

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.Assertions;

@SuppressWarnings("unused")
public class TestCases {
    private static final Adapter adapter = new Adapter();

    @BeforeAll
    public static void beforeAll() {
        adapter.beforeAll();
    }

    @BeforeEach
    public void beforeEach() {
        adapter.beforeEach();
    }

    @AfterEach
    public void afterEach() {
        adapter.afterEach();
    }

    @AfterAll
    public static void afterAll() {
        adapter.afterAll();
    }

    {%- macro convert_parameter(parameter) -%}
    {%- if parameter.type == 'bool' -%}
    {{ parameter.value.__str__().lower() }}
    {%- elif parameter.type == 'enum' -%}
    adapter.getEnum("{{ parameter.value.__str__() }}")
    {%- elif parameter.type == 'int' -%}
    {{ parameter.value.__str__() }}
    {%- else -%}
    {{ error('Unsupported parameter type: ' + parameter.type) }}
    {%- endif -%}
    {%- endmacro -%}

    {%- macro convert_parameters(parameters) -%}
    new Object[]{
    {%- for parameter in parameters -%}
    {%- if loop.index > 1 -%}, {%- endif -%}
    {{ convert_parameter(parameter) }}
    {%- endfor -%}
    }
    {%- endmacro %}

    {% for events in scenarios.get_scenarios_events() %}
    @Test
    public void testScenario{{ loop.index }}() throws InterruptedException {
        {{ scenarios.create_comments(events, '        ', '/*', ' *', ' */') }}
        {% for event in events -%}
        {% if event.kind == EventType.Command %}
        var result{{ loop.index }} = adapter.call("{{ event.method }}", {{ convert_parameters(event.parameters) }}, {{ convert_parameters(scenarios.get_reply_parameters(loop.index - 1, events)) }});
        {% elif event.kind == EventType.Signal %}
        adapter.call("{{ event.method }}", {{ convert_parameters(event.parameters) }});
        {% elif event.kind == EventType.Notification -%}
        var result{{ loop.index }} = adapter.waitForNotification("{{ event.method }}", {{ convert_parameters(event.parameters) }});
        Assertions.assertTrue(result{{ loop.index }});
        {% elif event.kind == EventType.Reply -%}
        Assertions.assertEquals({{ event.parameters|length }}, result{{ scenarios.get_command_index(event, events) + 1 }}.length);
        {% for parameter in event.parameters -%}
        Assertions.assertEquals({{ convert_parameter(parameter) }}, result{{ scenarios.get_command_index(event, events) + 1 }}[{{ loop.index - 1 }}]);
        {% endfor %}
        {%- endif %}
        {%- endfor %}
    }
    {% endfor %}
}